
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Coin_code_redemptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_code_redemptions = await db.coin_code_redemptions.create(
            {
                id: data.id || undefined,
        
        redeemed_at: data.redeemed_at
        ||
        null
            ,
            
        amount_doodlecoins: data.amount_doodlecoins
        ||
        null
            ,
            
        status_message: data.status_message
        ||
        null
            ,
            
        successful: data.successful
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await coin_code_redemptions.setCoin_code( data.coin_code || null, {
            transaction,
        });
        
        await coin_code_redemptions.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return coin_code_redemptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const coin_code_redemptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                redeemed_at: item.redeemed_at
            ||
            null
            ,
            
                amount_doodlecoins: item.amount_doodlecoins
            ||
            null
            ,
            
                status_message: item.status_message
            ||
            null
            ,
            
                successful: item.successful
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const coin_code_redemptions = await db.coin_code_redemptions.bulkCreate(coin_code_redemptionsData, { transaction });

        // For each item created, replace relation files
        

        return coin_code_redemptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const coin_code_redemptions = await db.coin_code_redemptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.redeemed_at !== undefined) updatePayload.redeemed_at = data.redeemed_at;
        
        
        if (data.amount_doodlecoins !== undefined) updatePayload.amount_doodlecoins = data.amount_doodlecoins;
        
        
        if (data.status_message !== undefined) updatePayload.status_message = data.status_message;
        
        
        if (data.successful !== undefined) updatePayload.successful = data.successful;
        
        
        updatePayload.updatedById = currentUser.id;

        await coin_code_redemptions.update(updatePayload, {transaction});

        
        
        if (data.coin_code !== undefined) {
            await coin_code_redemptions.setCoin_code(
              
              data.coin_code,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await coin_code_redemptions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return coin_code_redemptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const coin_code_redemptions = await db.coin_code_redemptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of coin_code_redemptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of coin_code_redemptions) {
                await record.destroy({transaction});
            }
        });


        return coin_code_redemptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const coin_code_redemptions = await db.coin_code_redemptions.findByPk(id, options);

        await coin_code_redemptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await coin_code_redemptions.destroy({
            transaction
        });

        return coin_code_redemptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const coin_code_redemptions = await db.coin_code_redemptions.findOne(
            { where },
            { transaction },
        );

        if (!coin_code_redemptions) {
            return coin_code_redemptions;
        }

        const output = coin_code_redemptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.coin_code = await coin_code_redemptions.getCoin_code({
            transaction
        });
        
        
        output.user = await coin_code_redemptions.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.coin_codes,
        as: 'coin_code',
        
        where: filter.coin_code ? {
          [Op.or]: [
            { id: { [Op.in]: filter.coin_code.split('|').map(term => Utils.uuid(term)) } },
            {
              code: {
                [Op.or]: filter.coin_code.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.status_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'coin_code_redemptions',
                        'status_message',
                        filter.status_message,
                    ),
                };
            }
            

            
            

            
            if (filter.redeemed_atRange) {
                const [start, end] = filter.redeemed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.amount_doodlecoinsRange) {
                const [start, end] = filter.amount_doodlecoinsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount_doodlecoins: {
                    ...where.amount_doodlecoins,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount_doodlecoins: {
                    ...where.amount_doodlecoins,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.successful) {
                where = {
                    ...where,
                successful: filter.successful,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.coin_code_redemptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'coin_code_redemptions',
                        'status_message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.coin_code_redemptions.findAll({
            attributes: [ 'id', 'status_message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status_message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status_message,
        }));
    }

    
};

